#! /bin/sh

CC=../inst/bin/gcc

export LD_LIBRARY_PATH=.

for t1 in lshared sshared lobject sobject; do
  case $t1 in
    lshared) 
      TARGET1="lib1.so"
      CFLAGS="-mcmodel=large -fPIC -Wl,-T,large-shared.ld -shared"
      ;;
    sshared) 
      TARGET1="lib1.so"
      CFLAGS="-mcmodel=small -fPIC -shared"
      ;;
    lobject) 
      TARGET1="obj1.o"
      CFLAGS="-mcmodel=large -c"
      ;;
    sobject) 
      TARGET1="obj1.o"
      CFLAGS="-mcmodel=small -c"
      ;;
  esac
  $CC $CFLAGS -o $TARGET1 lib1.c
  for t2 in lshared sshared lobject sobject; do
    case $t2 in
      lshared) 
	TARGET2="lib2.so"
	CFLAGS="-mcmodel=large -fPIC -Wl,-T,large-shared.ld -shared"
	;;
      sshared) 
	TARGET2="lib2.so"
	CFLAGS="-mcmodel=small -fPIC -shared"
	;;
      lobject) 
	TARGET2="obj2.o"
	CFLAGS="-mcmodel=large -c"
	;;
      sobject) 
	TARGET2="obj2.o"
	CFLAGS="-mcmodel=small -c"
	;;
    esac
    $CC $CFLAGS -o $TARGET2 lib2.c
    for app in large small; do
      echo -n "$t1 $t2 $app "
      # large app is not compatible with small objects
      if test $app = large; then
        case $t1:$t2 in
	  *sobject* ) echo "Skipping"; continue ;;
	esac
	CFLAGS="-mcmodel=large -Wl,-T,large-app.ld"
      else
        CFLAGS="-mcmodel=small"
      fi
      $CC $CFLAGS -o app app.c $TARGET1 $TARGET2
      ./app
    done
  done
done
